﻿Imports Meebey.SmartIrc4net
Imports System.Threading

Public Class Form1
    Public Shared irc As New IrcClient()
    ''' Network Settings
    Dim IRC_SERVER As String
    Dim IRC_PORT As Integer
    Dim IRC_CHANNEL As String
    Dim nickname As String

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        GroupBox2.Hide()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        GroupBox2.Show()
        GroupBox2.BringToFront()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Button1.Enabled = False
        nickname = TextBox7.Text
        IRC_SERVER = TextBox1.Text
        IRC_PORT = TextBox2.Text
        IRC_CHANNEL = TextBox3.Text
        AddHandler irc.OnConnected, AddressOf irc_OnConnected
        Dim Thrd As Thread
        Dim TStart As New ThreadStart(AddressOf BusyThread)
        Thrd = New Thread(TStart)
        Thrd.Priority = ThreadPriority.BelowNormal
        Thrd.Start()
        Try
            irc.Connect(IRC_SERVER, IRC_PORT)
        Catch ex As Exception
            MessageBox.Show("Connection error" & vbLf & vbLf & ex.ToString(), "Anon Error")
            Me.Close()
        End Try
    End Sub

    '''' IRC CLIENT
    Private Sub irc_OnConnected(ByVal sender As Object, ByVal e As System.EventArgs)
        irc.Login(nickname, "Anonymous_IRC1 BOT")
        irc.Listen(False)
        AddHandler irc.OnChannelMessage, AddressOf irc_OnChannelMessage
        AddHandler irc.OnDisconnected, AddressOf irc_disconnect
        AddHandler irc.OnDisconnecting, AddressOf irc_disconnect
        AddHandler irc.OnConnectionError, AddressOf irc_disconnect
        AddHandler irc.OnJoin, AddressOf irc_OnJoin
        AddHandler irc.OnKick, AddressOf irc_OnKick
        AddHandler irc.OnPart, AddressOf irc_Onpart
        AddHandler irc.OnConnected, AddressOf irc_OnConnected
        AddHandler irc.OnQuit, AddressOf irc_OnQuit
        irc.ActiveChannelSyncing = True
        irc.RfcJoin(IRC_CHANNEL)
        If CheckBox2.Checked = True Then
            irc.AutoRejoinOnKick = True
        Else
            irc.AutoRejoinOnKick = False
        End If
        Exit Sub
    End Sub

    Private Sub irc_OnQuit(ByVal sender As Object, ByVal e As QuitEventArgs)

    End Sub
    Private Sub irc_OnKick(ByVal sender As Object, ByVal e As KickEventArgs)

    End Sub
    Private Sub irc_Onpart(ByVal sender As Object, ByVal e As PartEventArgs)

    End Sub
    Private Sub irc_OnJoin(ByVal sender As Object, ByVal e As JoinEventArgs)

    End Sub
    Private Sub irc_disconnect(ByVal sender As Object, ByVal e As Meebey.SmartIrc4net.IrcEventArgs)
        If CheckBox3.Checked = True Then
            Application.Restart()
            My.Computer.FileSystem.WriteAllText("Settings.conf", "autorestart", False)
        End If
    End Sub
    Dim ban = 0
    Dim addusers = 1
    Private Sub irc_OnChannelMessage(ByVal sender As Object, ByVal e As Meebey.SmartIrc4net.IrcEventArgs)
        If CheckBox5.Checked = False Then
            Dim lines As String() = TextBox4.Lines '<- array create here.
            For i As Integer = 0 To lines.GetUpperBound(0)
                If e.Data.Message.Contains(TextBox4.Lines(i)) Then
                    irc.RfcKick(IRC_CHANNEL, e.Data.Nick, TextBox5.Text)
                    Dim kickban As String() = TextBox6.Lines
                    For kb As Integer = 0 To kickban.GetUpperBound(0)
                        If TextBox6.Lines(kb) = e.Data.Nick Then
                            addusers = 0
                        End If
                        If TextBox6.Lines(kb) = e.Data.Nick Then
                            ban = 1
                        End If
                    Next
                    If addusers = 1 Then
                        AddUser(e.Data.Nick)
                    End If
                    If CheckBox1.Checked = False Then
                        ban = 0
                    End If
                    If ban = 1 Then
                        If CheckBox5.Checked = True Then
                            irc.RfcMode(IRC_CHANNEL & " +b " & e.Data.Nick)
                        Else
                            irc.RfcMode(IRC_CHANNEL & " +b *!*@" & e.Data.Host)
                        End If
                    End If
                End If
            Next i
        Else
            Dim lines As String() = TextBox4.Lines '<- array create here.
            For i As Integer = 0 To lines.GetUpperBound(0)
                If e.Data.Message = (TextBox4.Lines(i)) Then
                    irc.RfcKick(IRC_CHANNEL, e.Data.Nick, TextBox5.Text)
                    Dim kickban As String() = TextBox6.Lines
                    For kb As Integer = 0 To kickban.GetUpperBound(0)
                        If TextBox6.Lines(kb) = e.Data.Nick Then
                            addusers = 0
                        End If
                        If TextBox6.Lines(kb) = e.Data.Nick Then
                            ban = 1
                        End If
                    Next
                    If addusers = 1 Then
                        AddUser(e.Data.Nick)
                    End If
                    If CheckBox1.Checked = False Then
                        ban = 0
                    End If
                    If ban = 1 Then
                        If CheckBox5.Checked = True Then
                            irc.RfcMode(IRC_CHANNEL & " +b " & e.Data.Nick)
                        Else
                            irc.RfcMode(IRC_CHANNEL & " +b *!*@" & e.Data.Host)
                        End If
                    End If
                End If
            Next i
        End If


        ban = 0
        addusers = 1
    End Sub

    Private Delegate Sub LogStatusAppendTextCallback(ByVal text As String)
    Private Sub AddUser(ByVal text As String)
        If Me.TextBox6.InvokeRequired Then
            Dim d As New LogStatusAppendTextCallback(AddressOf AddUser)
            Me.Invoke(d, New Object() {text})
        Else
            TextBox6.Text += text & vbNewLine
        End If
    End Sub

    Shared Sub BusyThread()
        On Error Resume Next
        While True
            If irc.IsConnected Then
                irc.ReadLine(True)
            End If
            If Not irc.IsConnected Then
                Thread.Sleep(100)
            End If
        End While
        On Error Resume Next
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Textbox1", TextBox1.Text)
        My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Textbox2", TextBox2.Text)
        My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Textbox3", TextBox3.Text)
        My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Textbox4", TextBox4.Text)
        My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Textbox5", TextBox5.Text)
        My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Textbox6", TextBox6.Text)
        My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Textbox7", TextBox7.Text)
        If CheckBox1.Checked = True Then
            My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Checkbox1", 1)
        Else
            My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Checkbox1", 0)
        End If
        If CheckBox2.Checked = True Then
            My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "CheckBox2", 1)
        Else
            My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "CheckBox2", 0)
        End If
        If CheckBox3.Checked = True Then
            My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "CheckBox3", 1)
        Else
            My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "CheckBox3", 0)
        End If
        If CheckBox4.Checked = True Then
            My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Checkbox4", 1)
        Else
            My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Checkbox4", 0)
        End If
        If CheckBox5.Checked = True Then
            My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Checkbox5", 1)
        Else
            My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Checkbox5", 0)
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' LOADING SETTINGS
        Dim Textbox1_Registery As Object
        Textbox1_Registery = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Textbox1", "")
        Dim Textbox2_Registery As Object
        Textbox2_Registery = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Textbox2", "")
        Dim Textbox3_Registery As Object
        Textbox3_Registery = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Textbox3", "")
        Dim Textbox4_Registery As Object
        Textbox4_Registery = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Textbox4", "")
        Dim Textbox5_Registery As Object
        Textbox5_Registery = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Textbox5", "")
        Dim Textbox6_Registery As Object
        Textbox6_Registery = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Textbox6", "")
        Dim Textbox7_Registery As Object
        Textbox7_Registery = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Textbox7", "")
        Dim Checkbox1_Registery As Object
        Checkbox1_Registery = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Checkbox1", "")
        Dim Checkbox2_Registery As Object
        Checkbox2_Registery = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Checkbox2", "")
        Dim Checkbox3_Registery As Object
        Checkbox3_Registery = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Checkbox3", "")
        Dim Checkbox4_Registery As Object
        Checkbox4_Registery = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Checkbox4", "")
        Dim Checkbox5_Registery As Object
        Checkbox5_Registery = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Anonymous\IRCBOT", "Checkbox5", "")

        TextBox1.Text = Textbox1_Registery
        TextBox2.Text = Textbox2_Registery
        TextBox3.Text = Textbox3_Registery
        TextBox4.Text = Textbox4_Registery
        TextBox5.Text = Textbox5_Registery
        TextBox6.Text = Textbox6_Registery
        TextBox7.Text = Textbox7_Registery
        If Checkbox1_Registery = 1 Then
            CheckBox1.Checked = True
        Else
            CheckBox1.Checked = False
        End If
        If Checkbox2_Registery = 1 Then
            CheckBox2.Checked = True
        Else
            CheckBox2.Checked = False
        End If
        If Checkbox3_Registery = 1 Then
            CheckBox3.Checked = True
        Else
            CheckBox3.Checked = False
        End If
        If Checkbox5_Registery = 1 Then
            CheckBox5.Checked = True
        Else
            CheckBox5.Checked = False
        End If
        If Checkbox5_Registery = 1 Then
            CheckBox5.Checked = True
        Else
            CheckBox5.Checked = False
        End If
        On Error Resume Next

        Dim fileContents As String
        fileContents = My.Computer.FileSystem.ReadAllText("Settings.conf")
        If fileContents = "autorestart" Then
            Button1.PerformClick()
        End If
        Kill("Settings.conf")
        On Error Resume Next
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        TextBox6.Text = Nothing
    End Sub
End Class
